;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------

.include "cpctelera.h.s"
.include "man/game.h.s"
.include "cpcteleraHeader.h.s"

.include "./sys/render.h.s"
.include "./sys/ai.h.s"
.include "./man/entity.h.s"
.include "./man/platform.h.s"
.include "./man/tilemap.h.s"
.include "./man/level.h.s"
.include "./man/interruptions.h.s"

.area _DATA
.area _CODE

.globl _tiles00_000
.globl cpct_disableFirmware_asm
.globl _platform_array


_main::
  CALL man_interruptions_init
  call sys_render_displaySetUp

  call man_level_init
  call man_game_init

  loop:
  CALL cpct_waitVSYNC_asm
  call man_game_update
  call man_game_render
  jr loop
