;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------
;
; Animations Manager 
;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Includes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "man/entity.h.s"
.include "man/animations.h.s"



; Viser (bat)
_animation_viser_not_detected:
  .dw    _spr_viser_1
  .dw    0x0000
  .dw    _animation_viser_not_detected

_animation_viser_detected:
  .dw    _spr_viser_2
  .dw    _spr_viser_3
  .dw    _spr_viser_4
  .dw    _spr_viser_5
  .dw    _spr_viser_6
  .dw    _spr_viser_7
  .dw    _spr_viser_8
  .dw    _spr_viser_9
  .dw    0x0000
  .dw    _animation_viser_detected


; Patrol
_animation_patrol:
  .dw   _spr_patrol_1
  .dw   _spr_patrol_1
  .dw   _spr_patrol_1
  .dw   _spr_patrol_1
  .dw   _spr_patrol_1
  .dw   _spr_patrol_2
  .dw   _spr_patrol_2
  .dw   _spr_patrol_2
  .dw   _spr_patrol_2
  .dw   _spr_patrol_2
  .dw   _spr_patrol_3
  .dw   _spr_patrol_3
  .dw   _spr_patrol_3
  .dw   _spr_patrol_3
  .dw   _spr_patrol_3
  .dw   _spr_patrol_4
  .dw   _spr_patrol_4
  .dw   _spr_patrol_4
  .dw   _spr_patrol_4
  .dw   _spr_patrol_4
  .dw    0x0000
  .dw    _animation_patrol



; Player
_animation_player_standing_right:
    .dw _spr_player_2
    .dw _spr_player_2
    .dw _spr_player_2
    .dw _spr_player_2
    .dw _spr_player_2
    .dw _spr_player_2
    .dw _spr_player_stand_2
    .dw _spr_player_stand_2
    .dw _spr_player_stand_2
    .dw _spr_player_stand_2
    .dw _spr_player_stand_2
    .dw 0x0000
    .dw _animation_player_standing_right

_animation_player_standing_left:

    .dw _spr_player_2_2
    .dw _spr_player_2_2
    .dw _spr_player_2_2
    .dw _spr_player_2_2
    .dw _spr_player_2_2
    .dw _spr_player_2_2
    .dw _spr_player_stand_2_left
    .dw _spr_player_stand_2_left
    .dw _spr_player_stand_2_left
    .dw _spr_player_stand_2_left
    .dw _spr_player_stand_2_left
    .dw 0x0000
    .dw _animation_player_standing_left

_animation_player_falling_left:
    .dw _spr_player_falling_left
    .dw 0x0000
    .dw _animation_player_falling_left

_animation_player_falling:
    .dw _spr_player_falling
    .dw 0x0000
    .dw _animation_player_falling

_animation_player_polvo:
    .dw _spr_player_polvo_1
    .dw _spr_player_polvo_1
    .dw _spr_player_polvo_2
    .dw _spr_player_polvo_2
    .dw _spr_player_polvo_3
    .dw _spr_player_polvo_3
    .dw 0x0000
    .dw _animation_player_standing_right

_animation_player_polvo_left:
    .dw _spr_player_polvo_1_left
    .dw _spr_player_polvo_1_left
    .dw _spr_player_polvo_2_left
    .dw _spr_player_polvo_2_left
    .dw _spr_player_polvo_3_left
    .dw _spr_player_polvo_3_left
    .dw 0x0000
    .dw _animation_player_standing_left

_animation_laser_on:
    .dw _spr_lasser
    .dw 0x0000
    .dw _animation_laser_on
_animation_laser_off:
    .dw _spr_lasser_off
    .dw 0x0000
    .dw _animation_laser_off
;:_animation_player_jumping_left:
;:    .dw _spr_player_2_jumping_left
;:    .dw _spr_player_standing_left
;:    .dw 0x0000
;:    .dw _animation_player_standing
