;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------
.include "cpctelera.h.s"
.include "interruptions.h.s"
.include "music.h.s"

man_wait_1:
    EX AF', AF
    EXX

    LD       A, #<man_wait_2  
    LD (#0x39), A
    LD       A, #>man_wait_2
    LD (#0x3A), A

    EX AF', AF
    EXX

    EI
RETI

man_wait_2:
    EX AF', AF
    EXX

    LD       A, #<man_wait_3
    LD (#0x39), A
    LD       A, #>man_wait_3
    LD (#0x3A), A


    EX AF', AF
    EXX

    EI
RETI

man_wait_3:
    PUSH HL
    EX AF', AF
    EXX


    LD       A, #<man_wait_4 
    LD (#0x39), A
    LD       A, #>man_wait_4
    LD (#0x3A), A

    ; LD       A, #<man_interruptions_music  
    ; LD (#0x39), A
    ; LD       A, #>man_interruptions_music
    ; LD (#0x40), A

    EX AF', AF
    EXX
    POP HL

    EI
RETI

man_wait_4:
    EX AF', AF
    EXX
    PUSH HL

    LD       A, #<man_wait_5  
    LD (#0x39), A
    LD       A, #>man_wait_5
    LD (#0x3A), A


    POP HL
    EX AF', AF
    EXX

    EI
RETI

man_wait_5:
    EX AF', AF
    EXX

    LD       A, #<man_interruptions_music  
    LD (#0x0039), A
    LD       A, #>man_interruptions_music
    LD (#0x003A), A

    EX AF', AF
    EXX

    EI
RETI

man_interruptions_music:
    PUSH AF
    PUSH BC
    PUSH DE
    PUSH HL

    CALL man_music_update
    CALL cpct_scanKeyboard_if_asm       ; Scan keyboard action

    LD   HL, #0x39                      ; Jump interruptions call dir
    LD (HL), #<man_wait_1               ; Low byte of function to call on interrupt
    INC  HL                             ; Byte #0x40
    LD (HL), #>man_wait_1               ; Low byte of function to call on interrupt

    POP HL
    POP DE
    POP BC
    POP AF

    EI
RETI

man_interruptions_init:
    CALL cpct_waitVSYNC_asm
    HALT
    HALT
    CALL cpct_waitVSYNC_asm

    LD   HL, #0x38                      ; Interruptions call in vector of interruptions
    LD (HL), #0xC3                      ; JP
    INC  HL                             ; Byte #0x39
    LD (HL), #<man_wait_1  ; Low byte of function to call on interrupt
    INC  HL                             ; Byte #0x40
    LD (HL), #>man_wait_1  ; Low byte of function to call on interrupt
    INC  HL                             ; Byte #0x41
    LD (HL), #0xC9                      ; RET
RET
