;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------
;
; Level Manager Header Files
;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Includes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Paletas
.globl _g_palette
.globl _g_palette_level_2
.globl _g_palette_level_3
.globl _g_palette_level_4
.globl _g_palette_level_5
.globl cpct_setPalette_asm

; Mapas
.globl _mapaMenu

.globl _level0_00
.globl _level1_00
.globl _level2_00
.globl _level3_00
.globl _level4_00
.globl _level5_00
.globl _level6_00
.globl _level7_00
.globl _level8_00
.globl _level9_00
.globl _level10_00
.globl _level11_00
.globl _level12_00
.globl _level13_00

; Tiles
.globl _tiles00_000

; Funciones
.globl man_level_init
.globl man_level_set_new_map
.globl man_level_dec_chunks_restantes
.globl man_level_load_next_level


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Variables
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
current_level_map:   .dw level_list_maps  ; Puntero a puntero
current_level_tile:  .dw level_list_tiles ; Puntero a puntero
current_level_tam:   .dw level_list_tams ; Puntero a puntero

chunks_restantes:    .db TAM_MAP_MENU


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Constantes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


; Tamanyos mapas
TAM_MAP_MENU = #0x20

TAM_MAP_00 = #58
TAM_MAP_01 = #82
TAM_MAP_02 = #68
TAM_MAP_03 = #70
TAM_MAP_04 = #75
TAM_MAP_05 = #77
TAM_MAP_06 = #80
TAM_MAP_07 = #70
TAM_MAP_08 = #80
TAM_MAP_09 = #90
TAM_MAP_10 = #90
TAM_MAP_11 = #120
TAM_MAP_12 = #110
TAM_MAP_13 = #42

; Listados
level_index_maps_tiles: .db #0x00
level_list_maps:        .dw _mapaMenu,     _level0_00,     _level1_00,    _level2_00,   _level3_00,   _level4_00, _level5_00, _level6_00, _level7_00, _level8_00, _level9_00, _level10_00, _level11_00, _level12_00, _level13_00

level_list_tiles:       .dw _tiles00_000,  _tiles00_000,   _tiles00_000,  _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000, _tiles00_000

level_list_tams:        .dw TAM_MAP_MENU,    TAM_MAP_00,     TAM_MAP_01,  TAM_MAP_02,   TAM_MAP_03,   TAM_MAP_04, TAM_MAP_05, TAM_MAP_06, TAM_MAP_07, TAM_MAP_08, TAM_MAP_09, TAM_MAP_10, TAM_MAP_11, TAM_MAP_12, TAM_MAP_13

