;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------
.globl man_music_init

.globl cpct_akp_SFXInit_asm
.globl cpct_akp_musicInit_asm
.globl cpct_akp_setFadeVolume_asm

.globl cpct_akp_musicPlay_asm
.globl cpct_akp_SFXPlay_asm

.globl cpct_akp_stop_asm

.globl man_music_activate_sfx
.globl man_music_update
.globl man_music_change_track
.globl man_music_toggle

.globl _wormhole
.globl _m_level_0
.globl _m_level_1
.globl _m_level_2
.globl _m_level_3
; .globl _m_level_4
.globl _sfx

SFX_DIE_LEN         = 2
SFX_JUMP_LEN        = 2
SFX_COMPLETED_LEN   = 3

;; SFX_IDs
DIE_SFX         = 0x01
JUMP_SFX        = 0x02
COMPLETED_SFX   = 0x04

;; MUSIC_TRACKS_IDs
MENU_TRACK      = 0x00
LEVEL0_TRACK    = 0x02
LEVEL4_TRACK    = 0x0A
LEVEL7_TRACK    = 0x10
LEVEL10_TRACK   = 0x18
FINAL_TRACK     = 0x1A

MUSIC_TRANSITION_CYCLES = 0xA0
FADE_UNDER_LIMIT        = 0x80
FADE_DEVIATION_APPLIED  = #0x03
