;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------
;
; Platform Manager Header
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Globals
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.globl max_platforms
.globl platformman_getPlatformArray_IX
.globl platformman_getPlatformArray_IY
.globl man_platform_init
.globl man_platform_new
.globl man_platform_create
.globl man_platform_update
.globl man_platform_forall_collision
.globl man_platform_forall_matching
.globl man_platform_destroy
.globl man_platform_set4destruction
.globl man_platform_freeSpace
.globl man_platform_one_move_single_scroll
.globl man_platform_crossed_limit_update
.globl man_platform_update_forall_position
.globl man_destroy_all_platforms

.globl man_platform_forall_matching_pos_y

.globl man_entity_tilerow_platform_update

.globl e_type_invalid
.globl e_type_render   
.globl e_type_dead     

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Variables
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

.globl _sp_platform
SPR_PLATFORM_H = 8
SPR_PLATFORM_W = 4

.globl _default_platform

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Constantes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
POSICION_SUPERIOR_PANTALLA    = 0x10
POSICION_INFERIOR_PANTALLA    = 0xF0
POSICION_INFERIOR_PLATAFORMA  = 0x68 ; Default 0xF0
NUM_POSICIONES_SCROLL         = 0x08


MARGIN_UP_PINCHO = 5

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Macros
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.macro DefinePlatform _name, _type, _x, _y, _w, _h
_name::
    DefinePlatformAnnonimous _type, _x, _y, _w, _h
.endm

.macro DefinePlatformAnnonimous _type, _x, _y, _w, _h
    .db _type
    .db _x
    .db _y
    .db _w
    .db _h
.endm

.macro DefineComponentArrayStructurePlatforms _Tname, _N, _DefineTypeMacroDefault
    _Tname'_num::    .db 0
    _Tname'_pend::   .dw _Tname'_array
    _Tname'_array::
        .rept _N
            _DefineTypeMacroDefault 0, 0, 0, 0, 0
        .endm
.endm

.macro DefinePlatformPointer _Tname, _N
_Tname'_pend:: .dw _Tname'_array
_Tname'_array::
    .rept _N
        .dw 0x0000
    .endm
.dw 0x0000
.endm

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Indexes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

p_type              = 0
p_x                 = 1
p_y                 = 2
p_w                 = 3
p_h                 = 4

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Global variables 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sizeof_p            = 5
