;;-----------------------------LICENSE NOTICE------------------------------------
;;  This file is part of ziloggames_z80 : An Amstrad CPC Game on Z80
;;  Copyright (C) 2022 Ander (@ander-db) / Carlos (@carlosky66) / Adrian (@RosiYo)
;;
;;  This program is free software: you can redistribute it and/or modify
;;  it under the terms of the GNU Lesser General Public License as published by
;;  the Free Software Foundation, either version 3 of the License, or
;;  (at your option) any later version.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU Lesser General Public License for more details.
;;
;;  You should have received a copy of the GNU Lesser General Public License
;;  along with this program.  If not, see <http://www.gnu.org/licenses/>.
;;------------------------------------------------------------------------------
;
; Collisions System
;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Includes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "collisions.h.s"
.include "man/game.h.s"
.include "man/entity.h.s"
.include "man/platform.h.s"
.include "cpctelera.h.s"
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Variables
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
collision_flag:: 
    .db 0

collision_flag_enemy:: 
    .db 0
; Devuelve en iy el puntero al array de flags
; Modifica:
;   IY

sys_collision_getCollisionFlagsIY::
    ld iy, #collision_flag
    ret

sys_collision_rec_IY:
    ptr_iy = .+2
    ld iy, #0

    ret

; Comprueba si hay colisión con un enemigo
; Input: 
;   IY - Puntero a la entidad de la plataforma
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_pincho::
    ld ix, #_entity_array
    ld a, X_ENTITY_POS(ix)
    add W_ENTITY_POS(ix)
    sub #MARGIN_ENTITY_PLAYER_X + 2
    sub p_x(iy)
    ret c
    
    ld a, p_x(iy)
    add p_w(iy)
    sub #MARGIN_ENTITY_PLAYER_X + 2
    sub X_ENTITY_POS(ix)
    ret c

    ld a, Y_ENTITY_POS(ix)
    add H_ENTITY_POS(ix)
    sub #(MARGIN_ENTITY_PLAYER_Y + 1 + MARGIN_UP_PINCHO)
    sub p_y(iy)
    ret c

    ld a, p_y(iy)
    add p_h(iy)
    sub #MARGIN_ENTITY_PLAYER_Y + 3
    sub Y_ENTITY_POS(ix)
    ret c

    collision_pincho:
        ld a, #0
        ld Y_ENTITY_POS(ix), a
        ld VY_ENTITY_POS(ix), a
        ld a, (_player_alive)
        cp #0
        ret z
        dec a
        ld (_player_alive), a
        ret
    non_collision_pincho:
        
        ret

sys_collision_update_one_enemy_up::
    ld a, Y_ENTITY_POS(iy)
    add H_ENTITY_POS(iy)
    sub #(MARGIN_ENTITY_PLAYER_Y + 3)
    sub Y_ENTITY_POS(ix)
    jr c, end_pt_u_enemy
        add #4
        sub H_ENTITY_POS(ix)
        jr z, col_u_enemy_true
            jr nc, end_pt_u_enemy
        col_u_enemy_true:
        ld a, PREV_PTR_POS_L(iy)
        add #MARGIN_ENTITY_PLAYER_X
        sub X_ENTITY_POS(ix)
        jr c, check_x_down_u_enemy
            add #1
            sub W_ENTITY_POS(ix)
                jr z, pt_u_enemy_col_true
                    jr c, pt_u_enemy_col_true
        check_x_down_u_enemy:
            ld a, PREV_PTR_POS_L(iy)
            add W_ENTITY_POS(iy)
            sub #MARGIN_ENTITY_PLAYER_X + 1
            sub X_ENTITY_POS(ix)
            jr c, end_pt_u_enemy
            add #1
            sub W_ENTITY_POS(ix)
                jr z, pt_u_enemy_col_true
                    jr nc, end_pt_u_enemy
    pt_u_enemy_col_true:
        ld a, #1
        ret
        

    end_pt_u_enemy:
        ld a, #0
        ret

eliminar_enemy:
    call man_entity_set4destruction
    ret

; Comprueba si hay colisión con un enemigo
; Input: 
;   IX - Puntero a la entidad enemigo
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_entity::
    ld iy, #_entity_array

    ld a, X_ENTITY_POS(iy)
    add W_ENTITY_POS(iy)
    sub #MARGIN_ENTITY_PLAYER_X + 2
    sub X_ENTITY_POS(ix)
    ret c
    ld a, X_ENTITY_POS(ix)
    add W_ENTITY_POS(ix)
    sub #MARGIN_ENTITY_PLAYER_X + 2
    sub X_ENTITY_POS(iy)
    ret c
;;
    ld a, Y_ENTITY_POS(iy)
    add H_ENTITY_POS(iy)
    sub #1
    sub #MARGIN_ENTITY_PLAYER_Y + 4
    sub Y_ENTITY_POS(ix)
    ret c
;;
    ld a, Y_ENTITY_POS(ix)
    add H_ENTITY_POS(ix)
    sub #5
    sub Y_ENTITY_POS(iy)
    ret c
;
    collision_enemy:
        ld a, #0
        ld Y_ENTITY_POS(iy), a
        ld VY_ENTITY_POS(iy), a
        ld a, (_player_alive)
        cp #0
        ret z
        dec a
        ld (_player_alive), a
        ret
    non_collision_enemy:
        
        ret

;if(prev_y+h-1 <= p_y && y+h-1 > p_y)
sys_collision_update_one_platform_up::
    ld a, Y_ENTITY_POS(ix)
    add H_ENTITY_POS(ix)
    sub #(MARGIN_ENTITY_PLAYER_Y + 1)
    sub p_y(iy)
    jr c, end_pt_u
        add #1
        sub p_h(iy)
        jr z, col_u_true
            jr nc, end_pt_u
        col_u_true:
        ld a, PREV_PTR_POS_L(ix)
        add #MARGIN_ENTITY_PLAYER_X
        sub p_x(iy)
        jr c, check_x_down_u
            add #1
            sub p_w(iy)
                jr z, pt_u_col_true
                    jr c, pt_u_col_true
        check_x_down_u:
            ld a, PREV_PTR_POS_L(ix)
            add W_ENTITY_POS(ix)
            sub #MARGIN_ENTITY_PLAYER_X + 1
            sub p_x(iy)
            jr c, end_pt_u
            add #1
            sub p_w(iy)
                jr z, pt_u_col_true
                    jr nc, end_pt_u
    pt_u_col_true:
        ld b, #col_flag_up
        jr collision_true_up

    end_pt_u:
        ld b, #col_flag_mask_up
        jr collision_false
            
; Comprueba si hay colisión con la parte de abajo de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_down::
    ld a, Y_ENTITY_POS(ix)
    add #(MARGIN_ENTITY_PLAYER_Y + 5)
    sub p_y(iy)
        jr z, end_pt_d
            jr c, end_pt_d
        add #1
        sub p_h(iy)
        jr z, col_d_true
            jr nc, end_pt_d
        col_d_true:
        ld a, PREV_PTR_POS_L(ix)
        add #MARGIN_ENTITY_PLAYER_X
        sub p_x(iy)
        jr c, check_x_down_d
            add #1
            sub p_w(iy)
                jr z, pt_d_col_true
                    jr c, pt_d_col_true
        check_x_down_d:
            ld a, PREV_PTR_POS_L(ix)
            add W_ENTITY_POS(ix)
            sub #MARGIN_ENTITY_PLAYER_X + 1
            sub p_x(iy)
            jr c, end_pt_d
            add #1
            sub p_w(iy)
                jr z, pt_d_col_true
                    jr nc, end_pt_d
    pt_d_col_true:
        ld b, #col_flag_down
        jr collision_true

    end_pt_d:
        ld b, #col_flag_mask_down
        jr collision_false
            

; Pone la flag de colision a la flag que corresponda 
; Input: 
;   A - Flag a guardar
; Modifica:
;   A, HL
collision_true:
    ld a, (collision_flag)
    or b
    ld (collision_flag), a
    ld a, #1
    ret

collision_true_up:
    ld a, #0
    ld (player_in_air), a
                     
    
    ld a, (collision_flag)
    or b
    ld (collision_flag), a
    ld a, #1
    
    ;ld (collision_flag), a
    ;ld hl, #0xC800
    ;ld (hl), #0xFF
    ret

; Aplica una máscara a la flag de colisión
; Input: 
;   B - Máscara a aplicar
; Modifica:
;   A, B, HL
collision_false:
    ld a, #0
    ret

; Comprueba si hay colisión con la parte izquierda de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_left::
    ld a, X_ENTITY_POS(ix)
    add W_ENTITY_POS(ix)
    sub #(MARGIN_ENTITY_PLAYER_X + 1)
    sub p_x(iy)
    jr nz, end_pt_l
        ld a, PREV_PTR_POS_H(ix)
        add #MARGIN_ENTITY_PLAYER_Y
        sub p_y(iy)
        jr c, check_y_down_l
            add #1
            sub p_h(iy)
                jr z, pt_l_col_true
                    jr c, pt_l_col_true
        check_y_down_l:
            ld a, PREV_PTR_POS_H(ix)
            add H_ENTITY_POS(ix)
            sub #MARGIN_ENTITY_PLAYER_Y + 1
            sub p_y(iy)
            jr c, end_pt_l
            add #1
            sub p_h(iy)
                jr z, pt_l_col_true
                    jr nc, end_pt_l
    pt_l_col_true:
        ld b, #col_flag_left
        jr collision_true

    end_pt_l:
        ld b, #col_flag_mask_left
        jr collision_false

; Comprueba si hay colisión con la parte derecha de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_right::
    ld a, p_x(iy)
    add p_w(iy)
    sub #(MARGIN_ENTITY_PLAYER_X + 1)
    sub X_ENTITY_POS(ix)
    jr nz, end_pt_r
        ld a, PREV_PTR_POS_H(ix)
        add #MARGIN_ENTITY_PLAYER_Y
        sub p_y(iy)
        jr c, check_y_down_r
            add #1
            sub p_h(iy)
                jr z, pt_r_col_true
                    jr c, pt_r_col_true
        check_y_down_r:
            ld a, PREV_PTR_POS_H(ix)
            add H_ENTITY_POS(ix)
            sub #MARGIN_ENTITY_PLAYER_Y + 1
            sub p_y(iy)
            jr c, end_pt_r
            add #1
            sub p_h(iy)
                jr z, pt_r_col_true
                    jr nc, end_pt_r

    pt_r_col_true:
        ld b, #col_flag_right
        jp collision_true

    end_pt_r:
        ld b, #col_flag_mask_right
        jp collision_false

; Comprueba si hay colisión con esquina superior izquierda de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_up_left_corner::
    ld a, X_ENTITY_POS(ix)
    add W_ENTITY_POS(ix)
    sub #MARGIN_ENTITY_PLAYER_X
    ld b, p_x(iy)
    cp p_x(iy)
    jr nz, pt_u_l_end_check_pt
        ld a, Y_ENTITY_POS(ix)
        add H_ENTITY_POS(ix)
        sub #(MARGIN_ENTITY_PLAYER_X + 1)
        cp p_y(iy)
        jr nz, pt_u_l_end_check_pt
            pt_u_l_collision_true:
                ld b, #col_flag_left
                jp collision_true
    pt_u_l_end_check_pt:
        ld b, #col_flag_mask_left
        jp collision_false

; Comprueba si hay colisión con esquina superior derecha de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_up_right_corner::
    ld a, p_x(iy)
    add p_w(iy)
    sub #MARGIN_ENTITY_PLAYER_X
    cp X_ENTITY_POS(ix)
    jr nz, pt_u_r_end_check_pt
        ld a, Y_ENTITY_POS(ix)
        add H_ENTITY_POS(ix)
        sub #(MARGIN_ENTITY_PLAYER_X + 1)
        cp p_y(iy)
        jr nz, pt_u_r_end_check_pt
            pt_u_r_collision_true:
                ld b, #col_flag_right
                jp collision_true
    pt_u_r_end_check_pt:
        ld b, #col_flag_mask_right
        jp collision_false

; Comprueba si hay colisión con esquina inferior izquierda de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_down_left_corner::
    ld a, X_ENTITY_POS(ix)
    add W_ENTITY_POS(ix)
    sub #MARGIN_ENTITY_PLAYER_X
    ld b, p_x(iy)
    cp p_x(iy)
    jr nz, pt_d_l_end_check_pt
        ld a, p_y(iy)
        add p_h(iy)
        sub #(MARGIN_ENTITY_PLAYER_X + 1)
        cp Y_ENTITY_POS(ix)
        jr nz, pt_d_l_end_check_pt
            pt_d_l_collision_true:
                ld b, #col_flag_down
                jp collision_true
    pt_d_l_end_check_pt:
        ld b, #col_flag_mask_down
        jp collision_false

; Comprueba si hay colisión con esquina inferior derecha de una plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform_down_right_corner::
    ld a, p_x(iy)
    add p_w(iy)
    sub #MARGIN_ENTITY_PLAYER_X
    cp X_ENTITY_POS(ix)
    jr nz, pt_d_r_end_check_pt
        ld a, p_y(iy)
        add p_h(iy)
        sub #(MARGIN_ENTITY_PLAYER_X + 1)
        cp Y_ENTITY_POS(ix)
        jr nz, pt_d_r_end_check_pt
            pt_d_r_collision_true:
                ld b, #col_flag_down
                jp collision_true
    pt_d_r_end_check_pt:
        ld b, #col_flag_mask_down
        jp collision_false
    
sys_collision_update_one_platform_inside::
    ld a, X_ENTITY_POS(ix)
    add W_ENTITY_POS(ix)
    sub #MARGIN_ENTITY_PLAYER_X
    sub X_ENTITY_POS(iy)
    jr c, no_collision_platform_inside

    ld a, X_ENTITY_POS(iy)
    add W_ENTITY_POS(iy)
    sub #MARGIN_ENTITY_PLAYER_X
    sub X_ENTITY_POS(ix)
    jr c, no_collision_platform_inside

    ld a, Y_ENTITY_POS(ix)
    add H_ENTITY_POS(ix)
    sub #MARGIN_ENTITY_PLAYER_Y
    sub Y_ENTITY_POS(iy)
    jr c, no_collision_platform_inside

    ld a, Y_ENTITY_POS(iy)
    add H_ENTITY_POS(iy)
    sub Y_ENTITY_POS(ix)
    jr c, no_collision_platform_inside

    collision_platform_inside:
        ld a, #1
        ret
    no_collision_platform_inside:
        ld a, #0
        ret
ajustar_up:
    ld a, (collision_flag)
    and #col_flag_up
    ret z
    ld a, p_y(iy)
    add #MARGIN_ENTITY_PLAYER_Y
    sub H_ENTITY_POS(ix)
    ld Y_ENTITY_POS(ix), a
    ld VY_ENTITY_POS(ix), #0
    ret
ajustar_down:
    ld a, (collision_flag)
    and #col_flag_down
    ret z
    ld a, p_y(iy)
    add p_h(iy)
    sub #MARGIN_ENTITY_PLAYER_Y + 5
    ld Y_ENTITY_POS(ix), a
    ld VY_ENTITY_POS(ix), #0
    ret
ajustar_right:
    ld a, (collision_flag)
    and #col_flag_right
    ret z
    ld a, p_x(iy)
    add p_w(iy)
    add #1
    sub #MARGIN_ENTITY_PLAYER_Y
    ld X_ENTITY_POS(ix), a
    ld VX_ENTITY_POS(ix), #0
    ret
ajustar_left:
    ld a, (collision_flag)
    and #col_flag_left
    ret z
    ld a, p_x(iy)
    sub W_ENTITY_POS(ix)
    sub #1
    add #(MARGIN_ENTITY_PLAYER_Y)
    ld X_ENTITY_POS(ix), a
    ld VX_ENTITY_POS(ix), #0
    ret

ajustar_inside:
    ld a, p_x(iy)
    sub W_ENTITY_POS(ix)
    sub #1
    add #(MARGIN_ENTITY_PLAYER_Y)
    ld X_ENTITY_POS(ix), a
    ld VX_ENTITY_POS(ix), #0
    ret

; Comprueba si hay colisión con alguna plataforma
; Input: 
;   IY - Puntero a la plataforma (player)
;   IX - Puntero a la entidad
; Modifica:
;   AF, BC, DE, HL
sys_collision_update_one_platform::
    call sys_collision_update_one_platform_right
    cp #1
    jr nz, no_col_r
        call ajustar_right
        ret
    no_col_r:
    call sys_collision_update_one_platform_left
    cp #1
    jr nz, no_col_l
        call ajustar_left
        ret
    no_col_l:
    call sys_collision_update_one_platform_down
    cp #1
    jr nz, no_col_d
        call ajustar_down
        ret
    no_col_d: 
    call sys_collision_update_one_platform_up
    cp #1
    jr nz, no_col_u
        call ajustar_up
        ret
    no_col_u: 

    ;call sys_collision_update_one_platform_inside
    ;cp #1
    ;jr nz, no_col_inside
    ;    call ajustar_inside
    no_col_inside: 

    ;call sys_collision_update_one_platform_up_left_corner
    ;call sys_collision_update_one_platform_up_right_corner
    ;call sys_collision_update_one_platform_down_left_corner
    ;call sys_collision_update_one_platform_down_right_corner

    ret

collision_enemy_check:
    ret

.macro setCollisionFlagsToZero
    ld a, #00
    ld (collision_flag), a
    ld (collision_flag_enemy), a
.endm

sys_collision_update::
    ;cpctm_setBorder_asm HW_RED
    setCollisionFlagsToZero
    call man_entity_getArray
    call man_platform_forall_collision
    ;cpctm_setBorder_asm HW_WHITE
    ld hl, #sys_collision_update_one_entity
    ld a, #E_TYPE_COLLISIONABLE
    call man_entity_forall_matching
    ;cpctm_setBorder_asm HW_GREEN

    ret
