;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Includes
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
.include "game.h.s"
.include "entity.h.s"
.include "platform.h.s"
.include "tilemap.h.s"
.include "sys/ai.h.s"
.include "sys/input.h.s"
.include "sys/collisions.h.s"
.include "sys/physics.h.s"
.include "sys/render.h.s"
.include "sys/animations.h.s"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;  Wait VSYNC the number of times in h
;;  INPUT:
;;      H - Number of VSYNC waits to do
;;  DESTROY:
;;      H, DE, BC, AF
wait_vsync:
    LD A, H
    wait_iter:
        CP   #0
        RET  Z
        LD   B, #2
        CALL cpct_waitHalts_asm
        CALL cpct_waitVSYNC_asm
        DEC  H
        LD   A, H
        JR   wait_iter

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Sets initial values used in game before starting a new game.
;; INPUT:
;; DESTROYS:
man_game_init:
    CALL sys_render_displaySetUp
    CALL man_entity_init
    CALL man_platform_init

    CALL man_entity_getArray
    CALL sys_ai_init
    CALL sys_physics_init
RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Sets initial values used in game before starting a new game.
;; INPUT:
;; DESTROYS:
man_game_update:
    CALL sys_ai_update
    CALL sys_input_update
    CALL sys_physics_update
    CALL sys_collision_update
    ;call sys_animations_update
RET

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Performs rendering process apart from game update to account 
;; for its time constraints
;; INPUT:
;; DESTROYS:
man_game_render:
    CALL sys_tilemap_update_new
    CALL sys_render_update
    CALL man_entity_update              ; tmp
<<<<<<< HEAD
    ; ld h, #5
    ; call wait_vsync
=======
    ;ld h, #5
    ;call wait_vsync
>>>>>>> deve
    ; CALL cpct_waitVSYNC_asm
RET
